"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
/* Copyright VMware, Inc. All rights reserved. VMware Confidential */
var core_1 = require("@angular/core");
var dragDrop_service_1 = require("./dragDrop.service");
var NgxDroppableDirective = (function () {
    function NgxDroppableDirective(el, dragDropService) {
        this.el = el;
        this.dragDropService = dragDropService;
        this.onDropData = new core_1.EventEmitter();
        this.dropTags = [this.dragDropService.instanceName];
    }
    NgxDroppableDirective.prototype.onDragEnter = function (event) {
        if (event.preventDefault) {
            event.preventDefault();
        }
        if (event.stopPropagation) {
            event.stopPropagation();
        }
        if (this.el.nativeElement === event.target) {
            if (this.dropTags.indexOf(this.dragDropService.instanceName) !== -1) {
                event.target.classList.add(this.dragDropService.instanceName);
            }
        }
    };
    NgxDroppableDirective.prototype.onDragOver = function (event) {
        if (event.preventDefault) {
            event.preventDefault();
        }
        if (event.stopPropagation) {
            event.stopPropagation();
        }
        if (this.el.nativeElement === event.target) {
            if (this.dropTags.indexOf(this.dragDropService.instanceName) !== -1) {
                event.dataTransfer.effectAllowed = 'all';
                event.dataTransfer.dropEffect = 'move';
            }
            else {
                event.dataTransfer.effectAllowed = 'none';
                event.dataTransfer.dropEffect = 'none';
            }
        }
    };
    NgxDroppableDirective.prototype.onDragLeave = function (event) {
        if (event.preventDefault) {
            event.preventDefault();
        }
        if (event.stopPropagation) {
            event.stopPropagation();
        }
        if (this.el.nativeElement === event.target) {
            if (this.dropTags.indexOf(this.dragDropService.instanceName) !== -1) {
                event.target.classList.remove(this.dragDropService.instanceName);
            }
        }
    };
    NgxDroppableDirective.prototype.onDrop = function (event) {
        if (event.preventDefault) {
            event.preventDefault();
        }
        if (event.stopPropagation) {
            event.stopPropagation();
        }
        if (this.el.nativeElement === event.target) {
            var dragTag = this.dragDropService.instanceName;
            var data = event.dataTransfer.getData('data');
            var dragData = JSON.parse(data).dd;
            if (this.dropTags.indexOf(this.dragDropService.instanceName) !== -1) {
                event.target.classList.remove(this.dragDropService.instanceName);
                this.onDropData.emit({ dragTag: dragTag, dragData: dragData, dropData: this.dropData });
            }
        }
    };
    return NgxDroppableDirective;
}());
__decorate([
    core_1.Output('ngx-droppable'),
    __metadata("design:type", core_1.EventEmitter)
], NgxDroppableDirective.prototype, "onDropData", void 0);
__decorate([
    core_1.Input('ngx-dropTags'),
    __metadata("design:type", Array)
], NgxDroppableDirective.prototype, "dropTags", void 0);
__decorate([
    core_1.Input('ngx-dropData'),
    __metadata("design:type", Object)
], NgxDroppableDirective.prototype, "dropData", void 0);
__decorate([
    core_1.HostListener('dragenter', ['$event']),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], NgxDroppableDirective.prototype, "onDragEnter", null);
__decorate([
    core_1.HostListener('dragover', ['$event']),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], NgxDroppableDirective.prototype, "onDragOver", null);
__decorate([
    core_1.HostListener('dragleave', ['$event']),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], NgxDroppableDirective.prototype, "onDragLeave", null);
__decorate([
    core_1.HostListener('drop', ['$event']),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], NgxDroppableDirective.prototype, "onDrop", null);
NgxDroppableDirective = __decorate([
    core_1.Directive({
        selector: '[ngx-droppable]'
    }),
    __metadata("design:paramtypes", [core_1.ElementRef, dragDrop_service_1.NgxDragDropService])
], NgxDroppableDirective);
exports.NgxDroppableDirective = NgxDroppableDirective;

//# sourceMappingURL=droppable.directive.js.map
